#include "histogram.h"

using namespace std;

static void
find_minmax(const vector<double>& numbers, double& min, double& max)
{
    min = numbers[0];
    max = numbers[0];
    // (     )
    for (double value : numbers)
    {
        if (value < min) {min = value;}
        else if (value > max) {max = value;}
    }
}

vector<size_t>
make_histogram(const vector<double>& numbers, size_t& bin_count)
{
    double min, max;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        for (size_t j = i + 1; j < numbers.size(); j++)
        {
            if (numbers[i] == numbers[j])
            {
                //numbers.erase(numbers.begin() + j);
                //number_count--;
                //i--;
                //cout << "Removed number " << numbers[j] << endl;
            }
        }
    }

    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
                auto low_bound = min + j * bin_size;
                auto high_bound = min + (j + 1) * bin_size;
                if ((low_bound <= numbers[i]) && (numbers[i] < high_bound))
                {
                    bins[j]++;
                    found = true;
                }
        }

        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    return bins;
}
